/*
    This file is part of Frozen Bubble for S60.

    Frozen Bubble for S60 is free software; you can redistribute
    it and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    Frozen Bubble for S60 is distributed in the hope that it
    will be useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Frozen Bubble for S60; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <e32base.h>
#include "MyActive.h"
#include "CMixerThread.h"

// Constructs and sets priority
MyActive::MyActive(CMixerThread* aThread):
CActive(CActive::EPriorityStandard),iThread(aThread) {
  // adds the active to the queue
  CActiveScheduler::Add(this) ; 
}


// Cancels this task
void MyActive::DoCancel() {
  TRequestStatus* status = &iStatus;
  RThread().RequestComplete(status,KErrCancel);
}


// Request accepting function
void MyActive::Request() {
  SetActive();  
  iStatus = KRequestPending;
}


// Informs the requestor that there is a user activity
// or timer is fired
void MyActive::RunL() {
  if(iStatus == KErrNone) {
    iThread->HandleExceptionL();
    Request();
  }
}

